;;;;;;;;;;;;;;BIGNUM v 1.0 - Multiprecision Library for NASM. 
;;;;;;;;;;;;;;
;;;;;;;;;;;;;;(Released on 15-jan-2007
;;;;;;;;;;;;;; Programmed by Mathi.
;;;;;;;;;;;;;;
;;;;;;;;;;;;;;Bug Reports can be sent to mathiisalive@yahoo.com
;;;;;;;;;;;;;;

%define SIZE_BIGNUM 1024 ; increase this variable to achieve higher precision.

%define ADDRESS "ADDR_",
%macro BIGNUM 1-*
jmp near %%afterRESBdata
section .bss
  %rep %0
       %1: resb SIZE_BIGNUM
       %rotate 1
  %endrep

section .code
%%afterRESBdata:
%endmacro

%macro BIGNUM2str 2-4
   %assign i	%0
   %rep %0
        %rotate -1
        %assign i	i-1
        %rotate -1 
        %ifidn %1,"ADDR_"
   	   %rotate 1
   	   lea	eax,	[%1]
   	   push	eax
   	   %rotate -1
   	   %assign i	i-1
        %else
        	   %rotate 1
   	   %ifstr %1
 	   	PushreversedString %1
 	   %else
 	   	push dword %1
 	   %endif
 	   
        %endif
        %if i <=0
        	   %exitrep
        %endif
  %endrep
  loccall _convertBIGNUM2str
%endmacro

%macro str2BIGNUM 2-4
  %assign i	%0
  %rep %0
       %rotate -1
       %assign i	i-1
       %rotate -1 
       %ifidn %1,"ADDR_"
  	   %rotate 1
  	   lea	eax,	[%1]
  	   push	eax
  	   %rotate -1
  	   %assign i	i-1
       %else
       	   %rotate 1
  	   %ifstr %1
	   	PushreversedString %1
	   %else
	   	push dword %1
	   %endif
	   
       %endif
       %if i <=0
       	   %exitrep
       %endif
  %endrep
  loccall _convertStr2BIGNUM
%endmacro

%macro PushreversedString 1
	%strlen charcnt %1
	%assign k charcnt
	jmp %%skip_reversedString
	%%reversedString:
	%rep charcnt
		%substr currentchar %1 k
		db currentchar & 0xF
		%assign k k-1
	%endrep
	%rep SIZE_BIGNUM - charcnt
		db 0
	%endrep
	%%skip_reversedString
	push dword %%reversedString
%endmacro
%macro addBIGNUM 2-*
  %assign i	%0
  %rep %0
       %rotate -1
       %assign i	i-1
       %rotate -1 
       %ifidn %1,"ADDR_"
  	   %rotate 1
  	   lea	eax,	[%1]
  	   push	eax
  	   %rotate -1
  	   %assign i	i-1
       %else
       	   %rotate 1
  	   %ifstr %1
	   	PushreversedString %1
	   %else
	   	push dword %1
	   %endif
	   
       %endif
       %if i <=0
       	   %exitrep
       %endif
  %endrep
  loccall _addtwoBIGNUMS
%endmacro

%macro subBIGNUM 2-4
  %assign i	%0
    %rep %0
       %rotate -1
       %assign i	i-1
       %rotate -1 
       %ifidn %1,"ADDR_"
  	   %rotate 1
  	   lea	eax,	[%1]
  	   push	eax
  	   %rotate -1
  	   %assign i	i-1
       %else
       	   %rotate 1
  	   %ifstr %1
  		PushreversedString %1
  	   %else
  	        push dword %1
  	   %endif
  	   
       %endif
       %if i <=0
         	   %exitrep
       %endif     
    %endrep
  
    loccall _subtwoBIGNUMS
%endmacro

%macro movBIGNUM 2-*
  %assign i	%0
  %rep %0
       %rotate -1
       %assign i	i-1
       %rotate -1 
       %ifidn %1,"ADDR_"
  	   %rotate 1
  	   lea	eax,	[%1]
  	   push	eax
  	   %rotate -1
  	   %assign i	i-1
       %else
       	   %rotate 1
  	   %ifstr %1
	   	PushreversedString %1
	   %else
	   	push dword %1
	   %endif
       %endif
       %if i <=0
       	   %exitrep
       %endif
  %endrep
  loccall _assignBIGNUM
%endmacro

%macro isZERO 1-*
     %ifidn %1,"ADDR_"
	   lea	eax,	[%2]
	   push	eax
     %else
	   %ifstr %1
	   	PushreversedString %1
	   %else
	   	push dword %1
	   %endif	   
     %endif
  loccall _iszeroBIGNUM
%endmacro

%macro ifBIGNUM 1
	%ifstr %1
		PushreversedString %1
	%else
		push dword %1
	%endif
	loccall _ifBIGNUMBER

%endmacro

%macro rotateLeft 2-4
%assign i	%0
  %rep %0
     %rotate -1
     %assign i	i-1
     %rotate -1 
     %ifidn %1,"ADDR_"
	   %rotate 1
	   lea	eax,	[%1]
	   push	eax
	   %rotate -1
	   %assign i	i-1
     %else
     	   %rotate 1
	   %ifstr %1
		PushreversedString %1
	   %else
	        push dword %1
	   %endif
	   
     %endif
     %if i <=0
       	   %exitrep
     %endif     
  %endrep
  loccall _rotateLeftBIGNUM
%endmacro
%macro rotateRight 2-4
%assign i	%0
  %rep %0
     %rotate -1
     %assign i	i-1
     %rotate -1 
     %ifidn %1,"ADDR_"
	   %rotate 1
	   lea	eax,	[%1]
	   push	eax
	   %rotate -1
	   %assign i	i-1
     %else
     	   %rotate 1
	   %ifstr %1
		PushreversedString %1
	   %else
	        push dword %1
	   %endif
	   
     %endif
     %if i <=0
       	   %exitrep
     %endif     
  %endrep
  loccall _rotateRightBIGNUM
%endmacro


%macro cmpBIGNUM 2-4
%assign i	%0
  %rep %0
     %rotate -1
     %assign i	i-1
     %rotate -1 
     %ifidn %1,"ADDR_"
	   %rotate 1
	   lea	eax,	[%1]
	   push	eax
	   %rotate -1
	   %assign i	i-1
     %else
     	   %rotate 1
	   %ifstr %1
		PushreversedString %1
	   %else
	        push dword %1
	   %endif
	   
     %endif
     %if i <=0
       	   %exitrep
     %endif     
  %endrep
  
	loccall _compareBIGNUM
%endmacro

%macro decBIGNUM 1-2
  %assign i	%0
  %rep %0
     %rotate -1
     %assign i	i-1
     %rotate -1 
     %ifidn %1,"ADDR_"
	   %rotate 1
	   lea	eax,	[%1]
	   push	eax
	   %rotate -1
	   %assign i	i-1
     %else
     	   %rotate 1
	   %ifstr %1
		PushreversedString %1
	   %else
	        push dword %1
	   %endif
	   
     %endif
     %if i <=0
       	   %exitrep
     %endif     
  %endrep
  
  loccall _decBIGNUM
%endmacro

%macro incBIGNUM 1-2
  %assign i	%0
  %rep %0
     %rotate -1
     %assign i	i-1
     %rotate -1 
     %ifidn %1,"ADDR_"
	   %rotate 1
	   lea	eax,	[%1]
	   push	eax
	   %rotate -1
	   %assign i	i-1
     %else
     	   %rotate 1
	   %ifstr %1
		PushreversedString %1
	   %else
	        push dword %1
	   %endif
	   
     %endif
     %if i <=0
       	   %exitrep
     %endif     
  %endrep
  
  loccall _incBIGNUM
%endmacro

%macro mulBIGNUM 3-6
  %assign i	%0
  %rep %0
     %rotate -1
     %assign i	i-1
     %rotate -1 
     %ifidn %1,"ADDR_"
	   %rotate 1
	   lea	eax,	[%1]
	   push	eax
	   %rotate -1
	   %assign i	i-1
     %else
     	   %rotate 1
	   %ifstr %1
		PushreversedString %1
	   %else
	        push dword %1
	   %endif
	   
     %endif
     %if i <=0
       	   %exitrep
     %endif     
  %endrep
  loccall _mulBIGNUM
%endmacro

%macro divBIGNUM 4-8
  %assign i	%0
  %rep %0
     %rotate -1
     %assign i	i-1
     %rotate -1 
     %ifidn %1,"ADDR_"
	   %rotate 1
	   lea	eax,	[%1]
	   push	eax
	   %rotate -1
	   %assign i	i-1
     %else
     	   %rotate 1
	   %ifstr %1
		PushreversedString %1
	   %else
	        push dword %1
	   %endif
	   
     %endif
     %if i <=0
       	   %exitrep
     %endif     
  %endrep
  loccall _divBIGNUM
%endmacro

