section .code

proc _convertStr2BIGNUM,destnum,srcstring
	pusha
	mov edi,[@srcstring]
	mov esi,[@destnum]
	
	mov ecx,-1
	mov al,0
	repne scasb
	dec edi
	dec edi
	not ecx
	dec ecx
	mov edx,SIZE_BIGNUM
	sub edx,ecx
     %$looptostoredigits:
        mov al,byte[edi]
        and al,0xF
	mov byte[esi],al
	dec edi
	inc esi
	loop %$looptostoredigits
	
	mov ecx,edx
	mov al,0
        mov edi,esi
        repne stosb
	
	popa
endproc

proc _divBIGNUM,quotient,remainder,num1,num2
	stack number1,SIZE_BIGNUM,number2,SIZE_BIGNUM,temp,SIZE_BIGNUM
	loccall _zeroedBIGNUM,[@quotient]
	loccall _zeroedBIGNUM,[@remainder]
	movBIGNUM ADDRESS @number1,[@num1]
	movBIGNUM ADDRESS @number2,[@num2]
	mov edi,[@quotient]
	cmpBIGNUM ADDRESS @number1, ADDRESS @number2
	cmp eax,0
	jnz %$numbers_not_equal
		;;quotient  = 1
		;;remainder = 0
		incBIGNUM [@quotient]
		return 1
	%$numbers_not_equal:
	cmp eax,-1
	jz near %$num1_less_than_num2
		xor edx,edx
		while eax,e,1
			rotateLeft ADDRESS @number2,1
			cmpBIGNUM ADDRESS @number1, ADDRESS @number2
			inc edx
		wend
		push edx
		rotateRight ADDRESS @number2,1
		
		%$div_next_digit:
		
		mov ecx,0
	    %$div_loop:
	    	inc ecx
	    	cmp ecx,10
	    	je %$reachedten
		push dword 0
		push ecx
		lea eax,[@number2]
		push eax
		lea eax,[@temp]
		push eax
		loccall _multiply_single_digit
	     	jmp %$checkthedifference
	     %$reachedten:
	        movBIGNUM ADDRESS @temp,ADDRESS @number2
	        rotateLeft ADDRESS @temp,1
	    %$checkthedifference:
		cmpBIGNUM ADDRESS @number1,ADDRESS @temp
		cmp eax,-1
		jnz %$div_loop
	    	addBIGNUM ADDRESS @number1, ADDRESS @number2
	    	cmpBIGNUM ADDRESS @number1,ADDRESS @temp
	    	if eax,e,-1
	    		call MessageBoxA,0,"Division Error","BIGNUM Error",0
	    	endif
		subBIGNUM ADDRESS @number1, ADDRESS @temp
		dec ecx
		rotateLeft [@quotient],1
		mov edi,[@quotient]
		mov [edi],cl
		
		dec edx
		jz %$div_normal_return
		rotateLeft ADDRESS @number1,1
	    %$addzeros_for_lowremain
		cmpBIGNUM ADDRESS @number1,ADDRESS @number2
		cmp eax,-1
		jnz %$div_next_digit
		rotateLeft [@quotient],1
		mov edi,[@quotient]
		mov byte[edi],0
		dec edx
		jz %$div_normal_return
		rotateLeft ADDRESS @number1,1
		jmp %$addzeros_for_lowremain
	%$num1_less_than_num2:
		;;quotient  = 0
		;;remainder = num1
		movBIGNUM [@remainder],[@num1]
		return 1
	%$div_normal_return:
		pop edx
		dec edx
		rotateRight ADDRESS @number1,edx
		movBIGNUM [@remainder],ADDRESS @number1
		mov eax,1
		
endproc

proc _rotateRightBIGNUM,number,howmany
	pusha
	mov edx,[@howmany]
	while edx,ne,0
		mov edi,[@number]
		mov bl,[edi]
		mov ecx,SIZE_BIGNUM -1
	     %$shiftbytetoleft
		mov al,[edi+1]
		stosb
		loop %$shiftbytetoleft
		mov [edi],bl
		dec edx
	wend
	popa
endproc

proc _rotateLeftBIGNUM,number,howmany
	pusha
	mov edx,[@howmany]
	std
	while edx,ne,0
		mov edi,[@number]
		add edi,SIZE_BIGNUM - 1
		mov bl,[edi]
		mov ecx,SIZE_BIGNUM - 1 
	   %$shiftbytetoright
		mov al,[edi-1]
		stosb
		loop %$shiftbytetoright
		mov [edi],bl
		dec edx
	wend
	cld
	popa
endproc

proc _mulBIGNUM,dest,src1,src2
	stack tempnum1,SIZE_BIGNUM,tempnum2,SIZE_BIGNUM,tempproduct,SIZE_BIGNUM
	pusha
	loccall _zeroedBIGNUM,[@dest]
	movBIGNUM ADDRESS @tempnum1,[@src1]
	movBIGNUM ADDRESS @tempnum2,[@src2]
	
	lea esi,[@tempnum2]
	xor ecx,ecx
    %$multiply_digit_loop:
	mov eax,0
	lodsb
	if al,ne,0
		loccall _multiply_single_digit,ADDRESS @tempproduct,ADDRESS @tempnum1,eax,ecx
		addBIGNUM [@dest],ADDRESS @tempproduct
	endif
	inc ecx
	cmp ecx,SIZE_BIGNUM
	jl %$multiply_digit_loop
	popa
endproc

proc _multiply_single_digit,tmpprod,t1,digit,pos
	stack carry,4
	pusha
	mov edi,[@tmpprod]
	mov esi,[@t1]
	mov ecx,[@pos]
	mov dword[@carry],0
	mov edx,ecx
	mov eax,0
	while edx,ne,0
		stosb
		dec edx
	wend
	mov ebx,[@digit]
	push ecx
	mov ecx,SIZE_BIGNUM
	pop edx
	sub ecx,edx
	
	%$single_digit_multiply_loop:
	lodsb
	if al,ne,0
		push ecx
		mul ebx
		add eax,dword[@carry]
		mov ecx,10
		xor edx,edx
		div ecx
		mov byte[edi],dl
		inc edi
		mov dword[@carry],eax
		pop ecx
	else
		mov eax,[@carry]
		mov dword[@carry],0
		stosb
	endif
	loop %$single_digit_multiply_loop
	popa
endproc


proc _compareBIGNUM,num1,num2
	pusha
	mov esi,[@num1]
	add esi,SIZE_BIGNUM - 1
	mov edi,[@num2]
	add edi,SIZE_BIGNUM - 1
	std
	mov ecx,SIZE_BIGNUM
	%$cmp_comparedigits:
	cmpsb
	jl %$cmp_return_minus_one
	jg %$cmp_return_one
  	loop %$cmp_comparedigits
  %$cmp_return_zero:
   cld
   popa
   return 0
  %$cmp_return_minus_one:
   cld
   popa   
   return -1
  %$cmp_return_one:
   cld
   popa 
   return 1
endproc

proc _iszeroBIGNUM,num
  pusha
  mov esi,[@num]
  mov ecx,SIZE_BIGNUM/4
  %$checkfornextzero:
	  lodsd
	  and eax,0x0F0F0F0F
	  test eax,eax
	  jnz %$iszero_returnzero
  loop %$checkfornextzero
  
%$iszero_returnone:
popa
return 1
  
%$iszero_returnzero:
popa
return 0

endproc

proc _zeroedBIGNUM,num
  pusha
  mov edi,[@num]
  mov eax,0
  mov ecx,SIZE_BIGNUM/4
  %$storezero:
    stosd
  loop %$storezero
  popa
endproc

proc _assignBIGNUM,num,value
  pusha
  mov ecx,SIZE_BIGNUM/4
  mov esi,[@value]
  mov edi,[@num]
  repne movsd
  popa
endproc

proc _ifBIGNUMBER,number
 pusha
 mov esi,[@number]
 mov ecx,SIZE_BIGNUM
 %$checknextdigit:
	 lodsb
	 cmp al,9
	 jg %$validBIGNUMDigits_return_zero
	 jl %$validBIGNUMDigits_return_zero
 loop %$checknextdigit
 %$validBIGNUMDigits_return_one:
 popa
 return 1
 %$validBIGNUMDigits_return_zero:
 popa
 return 0
endproc

proc _subtwoBIGNUMS,num1,num2
  pusha
  mov esi,[@num1]
  mov edi,[@num2]
  mov ecx,SIZE_BIGNUM
  while ecx,ne,0
	  lodsb 
	  cmp al,byte[edi]
	  jl %$negnumber
	  sub al,byte[edi]
	  jmp %$skipnegnumber
	%$negnumber:
	  mov bl,al
	  add al,10
	  sub al,byte[edi]
	  dec byte[esi]
	%$skipnegnumber:
	  mov byte[esi-1],al
	  inc edi
	  dec ecx
  wend	
  popa
endproc

proc _addtwoBIGNUMS2,dest,src1,src2
  stack carry,4
  pusha
  
  mov edx,[@dest]
  mov edi,[@src1]
  mov esi,[@src2]
  mov dword[@carry],0
  mov ecx,SIZE_BIGNUM
  while ecx,ne,0
  lodsb 
  add al,byte[edi]
  add al,byte[@carry]
  if al,ge,10
  	mov dword[@carry],1
  	sub al,10
  else
  	mov dword[@carry],0
  endif
  mov byte[edx],al
  inc edx
  inc edi
  dec ecx
  wend  
  popa
endproc

proc _addtwoBIGNUMS,num1,num2
  stack carry,4
  pusha
  mov edi,[@num1]
  mov esi,[@num2]
  mov dword[@carry],0
  mov ecx,SIZE_BIGNUM
  %$_add_nextdigit:
  lodsb 
  add al,byte[edi]
  add al,byte[@carry]
  if al,ge,10
  	mov dword[@carry],1
  	sub al,10
  else
  	mov dword[@carry],0
  endif
  stosb
  loop %$_add_nextdigit
  popa
endproc


proc _convertBIGNUM2str,number,outstr
  pusha
  mov esi,[@number]
  mov edi,[@outstr]
  mov ecx,SIZE_BIGNUM + 1
  add esi,ecx
  sub esi,2
  std
  xor ax,ax
  %$covert2str_while:
  cmp al,0
  jne %$str_storedigits
	lodsb
	dec ecx
	test ecx,ecx
	jz %$PowerBreakOutOfWhileLoop_convert
  jmp %$covert2str_while
  %$str_storedigits:
    add al,'0'
    mov[edi],al
    inc edi
    lodsb
  loop %$str_storedigits
  jmp %$appendnullchar_convert
 %$PowerBreakOutOfWhileLoop_convert:
 mov al,'0'
 mov [edi],al
 inc edi
 %$appendnullchar_convert:
 mov al,0
 mov [edi],al
 cld
 popa
endproc

proc _decBIGNUM,number
	pusha
	mov esi,[@number]
	mov ecx,SIZE_BIGNUM
	
	%$nextdigitfordec:
	lodsb
	cmp al,0
	jnz %$subtractone
	mov byte[esi-1],9
	loop %$nextdigitfordec
	popa
	return -1
	%$subtractone:
	dec al
	mov [esi-1],al
	popa
	return 1
endproc

proc _incBIGNUM,number
	pusha
	mov esi,[@number]
	mov ecx,SIZE_BIGNUM
	
	%$nextdigitforinc:
	lodsb
	cmp al,9
	jne %$additionofone
	mov byte[esi-1],0
	loop %$nextdigitforinc
	popa
	return -1
	%$additionofone:
	inc al
	mov [esi-1],al
	popa
	return 1
endproc

